%{

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <iostream>

using namespace std;

  /* compiled with flex with the -i flag so that case of the code being */
  /*    scaned is ignored. makes for easier more efficient scanning .   */

  int line_num = 1;

  char tokenString[80];

  int init_p = 1;
  int pos = 0;

  /* Function prints the start-point, end-point and the type of a token */
  void set_lisp( int& start, int leng )
  {
    yylloc.first_column = start;
    yylloc.first_line = line_num;
    yylloc.last_column = start + leng;
    yylloc.last_line = line_num;

    start += leng;
  }
%}



esc  _
alpha			[A-Za-z%]
one_digit		[2-9]
digit			[0-9]
esc_digit		{digit}|{esc}
long_digit		{digit}|[A-Z]
esc_long_digit		{long_digit}|{esc}
radix		{digit}{esc_digit}*"r"
int  {one_digit}|{digit}{esc_digit}+|{radix}{esc_long_digit}+
expon    [eE][+-]?{esc_digit}+
float    {digit}*"."{esc_digit}+{expon}?|{digit}+"."{esc_digit}*{expon}?|{digit}+{expon}|{radix}{esc_long_digit}*"."{esc_long_digit}+{expon}?|{radix}{esc_long_digit}+"."{esc_long_digit}*{expon}?|{radix}{esc_long_digit}+{expon}
dot  "."
id  "0"|"1"|{alpha}({alpha}|{digit}|[!?|])*
quote  [""]
string_char  [^_""\n]|esc[^\n]
ws  \t|" "
nl  \n                                         
 // ["\015"]  THIS LINE BELONE TO LAST LINE
 
/*reserved_op = [\[(),:;\]{}$\'|] | "=>" | "==>" | "+->" | ":=" | "==" ;
  */
future_word  "delay"|"fix"|"is"|"isnt"|"let"|"rule"
future_op    [\[{(]"|"|"|"[\]})]|[`&]|"||"
definable_op_word  "by"|"case"|"mod"|"quo"|"rem"
definable_op  [\-\\#*+/<=>@~\^]|"<<"|">>"|"<="|">="|"<-"|"->"|"\\/"|"/\\"|"**"|".."|"~="|"^="
pre_doc   "+++".*
post_doc  "++".*
comment   "--".*
string  \"[^\"]*\"

%%

{ws}             ++init_p;
{nl}             ++line_num;
"\015"           ++init_p;
{nl}"\015"       ++init_p; 
 

add         { set_lisp( init_p, yyleng);
              return ADD;}
always      { set_lisp( init_p, yyleng); 
              return ALWAYS;}
and         { set_lisp( init_p, yyleng);
              return AND;}
assert      { set_lisp( init_p, yyleng);
              return ASSERT;}
break       { set_lisp( init_p, yyleng);
              return BREAK;}
but         { set_lisp( init_p, yyleng);
              return BUT;}
catch       { set_lisp( init_p, yyleng);
              return CATCH;}
default     { set_lisp( init_p, yyleng);
              return DEFAULT;}
define      { set_lisp( init_p, yyleng);
              return DEFINE;}
delay       { set_lisp( init_p, yyleng);
              return DELAY;}
do          { set_lisp( init_p, yyleng);
              return DO;}
else        { set_lisp( init_p, yyleng);
              return ELSE;}
except      { set_lisp( init_p, yyleng);
              return EXCEPT;}
export      { set_lisp( init_p, yyleng);
              return EXPORT;}
extend      { set_lisp( init_p, yyleng);
              return EXTEND;}
fix         { set_lisp( init_p, yyleng);
              return FIX;}
fluid       { set_lisp( init_p, yyleng);
              return FLUID;}
for         { set_lisp( init_p, yyleng);
              return FOR;}
free        { set_lisp( init_p, yyleng);
              return FREE;}
from        { set_lisp( init_p, yyleng);
              return FROM;}
generate    { set_lisp( init_p, yyleng);
              return GENERATE;}
goto        { set_lisp( init_p, yyleng);
              return GOTO;}
has         { set_lisp( init_p, yyleng);
              return HAS;}
if          { set_lisp( init_p, yyleng);
              return IF;}
import      { set_lisp( init_p, yyleng);
              return IMPORT;}
in          { set_lisp( init_p, yyleng);
              return IN;}
inline      { set_lisp( init_p, yyleng);
              return INLINE;}
is          { set_lisp( init_p, yyleng);
              return IS;}
isnt        { set_lisp( init_p, yyleng);
              return ISNT;}
iterate     { set_lisp( init_p, yyleng);
              return ITERATE;}
let         { set_lisp( init_p, yyleng);
              return LET;}
local       { set_lisp( init_p, yyleng);
              return LOCAL;}
macro       { set_lisp( init_p, yyleng);
              return MACRO;}
never       { set_lisp( init_p, yyleng);
              return NEVER;}
not         { set_lisp( init_p, yyleng);
              return NOT;}
of          { set_lisp( init_p, yyleng);
              return OF;}
or          { set_lisp( init_p, yyleng);
              return OR;}
pretend     { set_lisp( init_p, yyleng);
              return PRETEND;}
ref         { set_lisp( init_p, yyleng);
              return REF;}
repeat      { set_lisp( init_p, yyleng);
              return REPEAT;}
return      { set_lisp( init_p, yyleng);
              return RETURN;}
rule        { set_lisp( init_p, yyleng);
              return RULE;}
select      { set_lisp( init_p, yyleng);
              return SELECT;}
then        { set_lisp( init_p, yyleng);
              return THEN;}
throw       { set_lisp( init_p, yyleng);
              return EXCEPT;}
to          { set_lisp( init_p, yyleng);
              return TO;}
try         { set_lisp( init_p, yyleng);
              return TRY;}
where       { set_lisp( init_p, yyleng);
              return WHERE;}
while       { set_lisp( init_p, yyleng);
              return WHILE;}
with        { set_lisp( init_p, yyleng);
              return WITH;}
yield       { set_lisp( init_p, yyleng);
              return YIELD;}


  /* Definable op words */
"by"        { set_lisp( init_p, yyleng);
              return BY;}
"case"      { set_lisp( init_p, yyleng);
              return CASE;}
"finally"   { set_lisp( init_p, yyleng);
              return FINALLY;} 
"mod"       { set_lisp( init_p, yyleng);
              return MOD;}
"quo"       { set_lisp( init_p, yyleng); 
              return QUO;}
"rem"       { set_lisp( init_p, yyleng);
              return REM;}


  /* when user include class,  the following MAY become keyword */

boolean|DoubleFloat|false|Integer|List|TextWriter|String|true|Character|MachineInteger|"List Integer"|"List DoubleFloat"|"List MachineInteger" {
    strncpy(tokenString,yytext,20);
    set_lisp( init_p, yyleng);
    return ID;
  }

  /* import functions */

stdout|newline|space|include|rep|per|Per {
  strncpy(tokenString,yytext,20);
  set_lisp( init_p, yyleng); 
  return ID;
 }


  /* pre_doc */
{pre_doc} {
  strncpy(tokenString,yytext,80);
  set_lisp( init_p, yyleng);
  return PREDOC ;
}


  /* post_doc */
{post_doc} {
   strncpy(tokenString,yytext,80); 
   set_lisp( init_p, yyleng);
   return POSTDOC;
 }


  /* Comment */
{comment} {
   strncpy(tokenString,yytext, 80);
   set_lisp( init_p, yyleng);
   return PREDOC;
}

  /* String */
{string} {
  strncpy(tokenString,yytext,80);
  set_lisp( init_p, yyleng);
  return STRING;
}

{id} {
  strncpy(tokenString,yytext, 80);
  set_lisp( init_p, yyleng);
  return ID;  
}
{float} {
  strncpy(tokenString,yytext, 80);
  set_lisp( init_p, yyleng);
  return FLOAT;
}
{int} {
  strncpy(tokenString,yytext, 80);
  set_lisp( init_p, yyleng);
  return INT;
}

  /* Definable ops */
"\\"    { set_lisp( init_p, yyleng);
          return SETMINUS; }
"#"     { set_lisp( init_p, yyleng);
          return POUND;}
"*"     { set_lisp( init_p, yyleng);
          return TIMES;}
"+"     { set_lisp( init_p, yyleng);
          return PLUS;}
"-"     { set_lisp( init_p, yyleng);
          return MINUS;}
"/"     { set_lisp( init_p, yyleng);
          return DIVIDE;}
"<"     { set_lisp( init_p, yyleng);
          return LESSTHAN;}
"="     { set_lisp( init_p, yyleng);
          return EQUALS;}
">"     { set_lisp( init_p, yyleng);
          return GREATERTHAN;}
"@"     { set_lisp( init_p, yyleng);
          return ATSIGN;}
"~"     { set_lisp( init_p, yyleng);
          return TILDE;}
"^"     { set_lisp( init_p, yyleng); 
          return CARET;}
"<<"    { set_lisp( init_p, yyleng);
          return VERY_LESS;}
">>"    { set_lisp( init_p, yyleng);
          return VERY_GREATER;}
"<="    { set_lisp( init_p, yyleng);
          return LESSEQ;}
">="    { set_lisp( init_p, yyleng);
          return GREATEREQ;}
"<-"    { set_lisp( init_p, yyleng);
          return GETS;}
"->"    { set_lisp( init_p, yyleng);
          return TO_SYMBOL;}
"\\/"   { set_lisp( init_p, yyleng);
          return JOIN;}
"/\\"   { set_lisp( init_p, yyleng);
          return MEET;}
"**"    { set_lisp( init_p, yyleng);
          return STARSTAR;}
".."    { set_lisp( init_p, yyleng);
          return DOTDOT;}
"~="    { set_lisp( init_p, yyleng);
          return UNEQUALS;}
"^="    { set_lisp( init_p, yyleng);
          return CARETEQUALS;}

  /* Reserved ops */
"$"     { set_lisp( init_p, yyleng);
          return DOLLAR;}
"'"     { set_lisp( init_p, yyleng);
          return SQUOTE;}
"("     { set_lisp( init_p, yyleng); 
          return LPAREN;}
")"     { set_lisp( init_p, yyleng);
          return RPAREN;}
"+->"   { set_lisp( init_p, yyleng);
          return FUN_ARROW;}
","     { set_lisp( init_p, yyleng);
          return COMMA;}
":"     { set_lisp( init_p, yyleng);
          return COLON;}
":="    { set_lisp( init_p, yyleng);
          return IS_ASSIGNED;}
";"     { set_lisp( init_p, yyleng);
          return SEMI;}
"==>"   { set_lisp( init_p, yyleng);
          return MACRO_IS;}
"=>"    { set_lisp( init_p, yyleng);
          return EXIT;}
"["     { set_lisp( init_p, yyleng);
          return LBRACK;}
"]"     { set_lisp( init_p, yyleng);
          return RBRACK;}
"{"     { set_lisp( init_p, yyleng);
          return LBRACE;}
"}"     { set_lisp( init_p, yyleng);
          return RBRACE;}
"=="    { set_lisp( init_p, yyleng);
          return VERY_EQUAL;}
"|"     { set_lisp( init_p, yyleng);
          return BAR;}

   /* Future ops */
"[|"    { set_lisp( init_p, yyleng);
          return LLBRACK;}
"{|"    { set_lisp( init_p, yyleng);
          return LLBRACK;}
"(|"    { set_lisp( init_p, yyleng);
          return LLPAREN;}
"|]"    { set_lisp( init_p, yyleng);
          return RRBRACK;}
"|}"    { set_lisp( init_p, yyleng);
          return RRBRACE;}
"|)"    { set_lisp( init_p, yyleng);
          return RRPAREN;}
"`"     { set_lisp( init_p, yyleng);
          return GRAVE;}
"&"     { set_lisp( init_p, yyleng);
          return AMPERSAND;}
"||"    { set_lisp( init_p, yyleng);
          return OROR;}

   /* Other ops - temperary colour as future ops*/
"::"    { set_lisp( init_p, yyleng);
          return DCOLON;}
"."     { set_lisp( init_p, yyleng);
          return DOT;}
":*"    { set_lisp( init_p, yyleng);
          return COLON_STAR;}
"+-"    { set_lisp( init_p, yyleng);
          return PLUSMINUS;}


%%

int yywrap()
{
    return 1;
}
