%{

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <iostream>

using namespace std;

  /* compiled with flex with the -i flag so that case of the code being */
  /*    scaned is ignored. makes for easier more efficient scanning .   */

  int line_num = 1;

  char tokenString[80];

  int init_p = 1;
  int pos = 0;

  const bool flag = 1;

  /* Function prints the start-point, end-point and the type of a token */
  void print_lisp( int& start, int leng, char* type, char* text )
  {
    yylloc.first_column = start;
    yylloc.first_line = line_num;
    yylloc.last_column = start + leng;
    yylloc.last_line = line_num;

    if (flag);
    // cout << start << " " << start + leng << " " << type 
    //	   << "\t ---------------> " << text << endl;
    else
      cout << "( " << start << " " << start + leng << " " << type << " ) ";
    start += leng;
  }

  void print_overlay( int start, int end, char* type )
  {
      cout << "(setq overlay-" << pos << " (make-overlay "
	   << start << " " << end << " (get-buffer current-buffer)))" << endl;

      cout << "(overlay-put overlay-" << pos << " 'aldor-syntax '"
	   << type << ")" << endl << endl;

      ++pos;
  }

%}



esc  _
alpha			[A-Za-z%]
one_digit		[2-9]
digit			[0-9]
esc_digit		{digit}|{esc}
long_digit		{digit}|[A-Z]
esc_long_digit		{long_digit}|{esc}
radix		{digit}{esc_digit}*"r"
int  {one_digit}|{digit}{esc_digit}+|{radix}{esc_long_digit}+
expon    [eE][+-]?{esc_digit}+
float    {digit}*"."{esc_digit}+{expon}?|{digit}+"."{esc_digit}*{expon}?|{digit}+{expon}|{radix}{esc_long_digit}*"."{esc_long_digit}+{expon}?|{radix}{esc_long_digit}+"."{esc_long_digit}*{expon}?|{radix}{esc_long_digit}+{expon}
dot  "."
id  "0"|"1"|{alpha}({alpha}|{digit}|[!?|])*
quote  [""]
string_char  [^_""\n]|esc[^\n]
ws  \t|" "
nl  \n                                         
 // ["\015"]  THIS LINE BELONE TO LAST LINE
 
/*reserved_op = [\[(),:;\]{}$\'|] | "=>" | "==>" | "+->" | ":=" | "==" ;
  */
future_word  "delay"|"fix"|"is"|"isnt"|"let"|"rule"
future_op    [\[{(]"|"|"|"[\]})]|[`&]|"||"
definable_op_word  "by"|"case"|"mod"|"quo"|"rem"
definable_op  [\-\\#*+/<=>@~\^]|"<<"|">>"|"<="|">="|"<-"|"->"|"\\/"|"/\\"|"**"|".."|"~="|"^="
pre_doc   "+++".*
post_doc  "++".*
comment   "--".*
string  \"[^\"]*\"

%%

{ws}             ++init_p;
{nl}             ++line_num;
"\015"           ++init_p;
{nl}"\015"       ++init_p; 
 

add         { print_lisp( init_p, yyleng, "reserved", "ADD" );
              return ADD;}
always      { print_lisp( init_p, yyleng, "reserved", "ALWAYS" ); 
              return ALWAYS;}
and         { print_lisp( init_p, yyleng, "reserved", "AND" );
              return AND;}
assert      { print_lisp( init_p, yyleng, "reserved", "ASSERT" );
              return ASSERT;}
break       { print_lisp( init_p, yyleng, "reserved", "BREAK" );
              return BREAK;}
but         { print_lisp( init_p, yyleng, "reserved", "BUT" );
              return BUT;}
catch       { print_lisp( init_p, yyleng, "reserved", "CATCH" );
              return CATCH;}
default     { print_lisp( init_p, yyleng, "reserved", "DEFAULT" );
              return DEFAULT;}
define      { print_lisp( init_p, yyleng, "reserved", "DEFINE" );
              return DEFINE;}
delay       { print_lisp( init_p, yyleng, "reserved", "DELAY" );
              return DELAY;}
do          { print_lisp( init_p, yyleng, "reserved", "DO" );
              return DO;}
else        { print_lisp( init_p, yyleng, "reserved", "ELSE" );
              return ELSE;}
except      { print_lisp( init_p, yyleng, "reserved", "EXCEPT" );
              return EXCEPT;}
export      { print_lisp( init_p, yyleng, "reserved", "EXPORT" );
              return EXPORT;}
extend      { print_lisp( init_p, yyleng, "reserved", "EXTEND" );
              return EXTEND;}
fix         { print_lisp( init_p, yyleng, "reserved", "FIX" );
              return FIX;}
fluid       { print_lisp( init_p, yyleng, "reserved", "FLUID" );
              return FLUID;}
for         { print_lisp( init_p, yyleng, "reserved", "FOR" );
              return FOR;}
free        { print_lisp( init_p, yyleng, "reserved", "FREE" );
              return FREE;}
from        { print_lisp( init_p, yyleng, "reserved", "FROM" );
              return FROM;}
generate    { print_lisp( init_p, yyleng, "reserved", "GENERATE" );
              return GENERATE;}
goto        { print_lisp( init_p, yyleng, "reserved", "GOTO" );
              return GOTO;}
has         { print_lisp( init_p, yyleng, "reserved", "HAS" );
              return HAS;}
if          { print_lisp( init_p, yyleng, "reserved", "IF" );
              return IF;}
import      { print_lisp( init_p, yyleng, "reserved", "IMPORT" );
              return IMPORT;}
in          { print_lisp( init_p, yyleng, "reserved", "IN" );
              return IN;}
inline      { print_lisp( init_p, yyleng, "reserved", "INLINE" );
              return INLINE;}
is          { print_lisp( init_p, yyleng, "reserved", "IS" );
              return IS;}
isnt        { print_lisp( init_p, yyleng, "reserved", "ISNT" );
              return ISNT;}
iterate     { print_lisp( init_p, yyleng, "reserved", "ITERATE" );
              return ITERATE;}
let         { print_lisp( init_p, yyleng, "reserved", "LET" );
              return LET;}
local       { print_lisp( init_p, yyleng, "reserved", "LOCAL" );
              return LOCAL;}
macro       { print_lisp( init_p, yyleng, "reserved", "MACRO" );
              return MACRO;}
never       { print_lisp( init_p, yyleng, "reserved", "NEVER" );
              return NEVER;}
not         { print_lisp( init_p, yyleng, "reserved", "NOT" );
              return NOT;}
of          { print_lisp( init_p, yyleng, "reserved", "OF" );
              return OF;}
or          { print_lisp( init_p, yyleng, "reserved", "OR" );
              return OR;}
pretend     { print_lisp( init_p, yyleng, "reserved", "PRETEND" );
              return PRETEND;}
ref         { print_lisp( init_p, yyleng, "reserved", "REF" );
              return REF;}
repeat      { print_lisp( init_p, yyleng, "reserved", "REPEAT" );
              return REPEAT;}
return      { print_lisp( init_p, yyleng, "reserved", "RETURN" );
              return RETURN;}
rule        { print_lisp( init_p, yyleng, "reserved", "RULE" );
              return RULE;}
select      { print_lisp( init_p, yyleng, "reserved", "SELECT" );
              return SELECT;}
then        { print_lisp( init_p, yyleng, "reserved", "THEN" );
              return THEN;}
throw       { print_lisp( init_p, yyleng, "reserved", "THROW" );
              return EXCEPT;}
to          { print_lisp( init_p, yyleng, "reserved", "TO" );
              return TO;}
try         { print_lisp( init_p, yyleng, "reserved", "TRY" );
              return TRY;}
where       { print_lisp( init_p, yyleng, "reserved", "WHERE" );
              return WHERE;}
while       { print_lisp( init_p, yyleng, "reserved", "WHILE" );
              return WHILE;}
with        { print_lisp( init_p, yyleng, "reserved", "WITH" );
              return WITH;}
yield       { print_lisp( init_p, yyleng, "reserved", "YIELD" );
              return YIELD;}


  /* Definable op words */
"by"        { print_lisp( init_p, yyleng, "def_op_word", "BY" );
              return BY;}
"case"      { print_lisp( init_p, yyleng, "def_op_word", "CASE" );
              return CASE;}
"finally"   { print_lisp( init_p, yyleng, "def_op_word", "FINALLY" );
              return FINALLY;} 
"mod"       { print_lisp( init_p, yyleng, "def_op_word", "MOD" );
              return MOD;}
"quo"       { print_lisp( init_p, yyleng, "def_op_word", "QUO" ); 
              return QUO;}
"rem"       { print_lisp( init_p, yyleng, "def_op_word", "REM" );
              return REM;}


  /* when user include class,  the following MAY become keyword */

boolean|DoubleFloat|false|Integer|List|TextWriter|String|true|Character|MachineInteger|"List Integer"|"List DoubleFloat"|"List MachineInteger" {
    strncpy(tokenString,yytext,20);
    print_lisp( init_p, yyleng, "class", yytext );
    return ID;
  }

  /* import functions */

stdout|newline|space|include|rep|per|Per {
  strncpy(tokenString,yytext,20);
  print_lisp( init_p, yyleng, "import_function", yytext); 
  return ID;
 }


  /* pre_doc */
{pre_doc} {
  strncpy(tokenString,yytext,80);
  print_lisp( init_p, yyleng, "pre_doc", yytext);
  return PREDOC ;
}


  /* post_doc */
{post_doc} {
   strncpy(tokenString,yytext,80); 
   print_lisp( init_p, yyleng, "post_doc", yytext);
   return POSTDOC;
 }


  /* Comment */
{comment} {
   strncpy(tokenString,yytext, 80);
   print_lisp( init_p, yyleng, "comment", yytext);
   return PREDOC;
}

  /* String */
{string} {
  strncpy(tokenString,yytext,80);
  print_lisp( init_p, yyleng, "string", yytext);
  return STRING;
}

{id} {
  strncpy(tokenString,yytext, 80);
  print_lisp( init_p, yyleng, "id", yytext);
  return ID;  
}
{float} {
  strncpy(tokenString,yytext, 80);
  print_lisp( init_p, yyleng, "float", yytext);
  return FLOAT;
}
{int} {
  strncpy(tokenString,yytext, 80);
  print_lisp( init_p, yyleng, "int", yytext);
  return INT;
}

  /* Definable ops */
"\\"    { print_lisp( init_p, yyleng, "def_op", "SETMINUS" );
          return SETMINUS; }
"#"     { print_lisp( init_p, yyleng, "def_op", "POUND" );
          return POUND;}
"*"     { print_lisp( init_p, yyleng, "def_op", "TIMES" );
          return TIMES;}
"+"     { print_lisp( init_p, yyleng, "def_op", "PLUS" );
          return PLUS;}
"-"     { print_lisp( init_p, yyleng, "def_op", "MINUS" );
          return MINUS;}
"/"     { print_lisp( init_p, yyleng, "def_op", "DIVIDE" );
          return DIVIDE;}
"<"     { print_lisp( init_p, yyleng, "def_op", "LESSTHAN" );
          return LESSTHAN;}
"="     { print_lisp( init_p, yyleng, "def_op", "EQUALS" );
          return EQUALS;}
">"     { print_lisp( init_p, yyleng, "def_op", "GREATERTHAN" );
          return GREATERTHAN;}
"@"     { print_lisp( init_p, yyleng, "def_op", "ATSIGN" );
          return ATSIGN;}
"~"     { print_lisp( init_p, yyleng, "def_op", "TILDE" );
          return TILDE;}
"^"     { print_lisp( init_p, yyleng, "def_op", "CARET" ); 
          return CARET;}
"<<"    { print_lisp( init_p, yyleng, "def_op", "VERY_LESS" );
          return VERY_LESS;}
">>"    { print_lisp( init_p, yyleng, "def_op", "VERY_GREATER" );
          return VERY_GREATER;}
"<="    { print_lisp( init_p, yyleng, "def_op", "LESSEQ" );
          return LESSEQ;}
">="    { print_lisp( init_p, yyleng, "def_op", "GREATEREQ" );
          return GREATEREQ;}
"<-"    { print_lisp( init_p, yyleng, "def_op", "GETS" );
          return GETS;}
"->"    { print_lisp( init_p, yyleng, "def_op", "TO_SYMBOL" );
          return TO_SYMBOL;}
"\\/"   { print_lisp( init_p, yyleng, "def_op", "JOIN" );
          return JOIN;}
"/\\"   { print_lisp( init_p, yyleng, "def_op", "MEET" );
          return MEET;}
"**"    { print_lisp( init_p, yyleng, "def_op", "STARSTAR" );
          return STARSTAR;}
".."    { print_lisp( init_p, yyleng, "def_op", "DOTDOT" );
          return DOTDOT;}
"~="    { print_lisp( init_p, yyleng, "def_op", "UNEQUALS" );
          return UNEQUALS;}
"^="    { print_lisp( init_p, yyleng, "def_op", "CARETEQUALS" );
          return CARETEQUALS;}

  /* Reserved ops */
"$"     { print_lisp( init_p, yyleng, "res_op", "DOLLAR" );
          return DOLLAR;}
"'"     { print_lisp( init_p, yyleng, "res_op", "SQUOTE" );
          return SQUOTE;}
"("     { print_lisp( init_p, yyleng, "res_op", "LPAREN" ); 
          return LPAREN;}
")"     { print_lisp( init_p, yyleng, "res_op", "RPAREN" );
          return RPAREN;}
"+->"   { print_lisp( init_p, yyleng, "res_op", "FUN_ARROW" );
          return FUN_ARROW;}
","     { print_lisp( init_p, yyleng, "res_op", "COMMA" );
          return COMMA;}
":"     { print_lisp( init_p, yyleng, "res_op", "COLON" );
          return COLON;}
":="    { print_lisp( init_p, yyleng, "res_op", "IS_ASSIGNED" );
          return IS_ASSIGNED;}
";"     { print_lisp( init_p, yyleng, "res_op", "SEMI" );
          return SEMI;}
"==>"   { print_lisp( init_p, yyleng, "res_op", "MACRO_IS" );
          return MACRO_IS;}
"=>"    { print_lisp( init_p, yyleng, "res_op", "EXIT" );
          return EXIT;}
"["     { print_lisp( init_p, yyleng, "res_op", "LBRACK" );
          return LBRACK;}
"]"     { print_lisp( init_p, yyleng, "res_op", "RBRACK" );
          return RBRACK;}
"{"     { print_lisp( init_p, yyleng, "res_op", "LBRACE" );
          return LBRACE;}
"}"     { print_lisp( init_p, yyleng, "res_op", "RBRACE" );
          return RBRACE;}
"=="    { print_lisp( init_p, yyleng, "res_op", "VERY_EQUAL" );
          return VERY_EQUAL;}
"|"     { print_lisp( init_p, yyleng, "res_op", "BAR" );
          return BAR;}

   /* Future ops */
"[|"    { print_lisp( init_p, yyleng, "future_op", "LLBRACK" );
          return LLBRACK;}
"{|"    { print_lisp( init_p, yyleng, "future_op", "LLBRACE" );
          return LLBRACK;}
"(|"    { print_lisp( init_p, yyleng, "future_op", "LLPAREN" );
          return LLPAREN;}
"|]"    { print_lisp( init_p, yyleng, "future_op", "RRBRACK" );
          return RRBRACK;}
"|}"    { print_lisp( init_p, yyleng, "future_op", "RRBRACE" );
          return RRBRACE;}
"|)"    { print_lisp( init_p, yyleng, "future_op", "RRPAREN" );
          return RRPAREN;}
"`"     { print_lisp( init_p, yyleng, "future_op", "GRAVE" );
          return GRAVE;}
"&"     { print_lisp( init_p, yyleng, "future_op", "AMPERSAND" );
          return AMPERSAND;}
"||"    { print_lisp( init_p, yyleng, "future_op", "OROR" );
          return OROR;}

   /* Other ops - temperary colour as future ops*/
"::"    { print_lisp( init_p, yyleng, "future_op", "DCOLON");
          return DCOLON;}
"."     { print_lisp( init_p, yyleng, "future_op", "DOT");
          return DOT;}
":*"    { print_lisp( init_p, yyleng, "future_op", "COLON_STAR");
          return COLON_STAR;}
"+-"    { print_lisp( init_p, yyleng, "future_op", "PLUSMINUS");
          return PLUSMINUS;}


%%

int yywrap()
{
    return 1;
}
