#ifndef _UTIL_H_
#define _UTIL_H_


#include "global.h"
#include "aldor_parser.tab.h"
#include <iostream>

using namespace std;

// Print function for the tokens
void printToken( TokenType, const char* );


// newNode() create a new Node with all the initialization
TreeNode * newNode();

// newDeclNode(DeclKind) create new Declaration Node
TreeNode * newDeclNode(DeclKind);

// newStmtNode(StmtKind) create new Statement Node
TreeNode * newStmtNode(StmtKind);

// newInfixNode(InfixKind) create new Infixed Node
TreeNode * newInfixNode(InfixKind);

// newExpNode(ExpKind) create new Expression Node
TreeNode * newExpNode(ExpKind);

// newEncNode(EncKind) create new Enclosure Node
TreeNode * newEncNode(EncKind);

// newBlocklNode(BlockKind) create new Block Node
TreeNode * newBlockNode(BlockKind);


// newName(char* name) create a new node with the name "name"
TreeNode * newName(char*);

// copyString allocates and makes a new copy of an existing string
char * copyString( char * );


// printTree( TreeNode* ) print the parse tree
void printTree( TreeNode *, char* );

#include "util.c"

#endif


